package com.zhentao.user.controller;

import com.zhentao.config.NullLogin;
import com.zhentao.user.dto.*;
import com.zhentao.user.service.UserLoginService;
import com.zhentao.vo.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;


@RestController
@RequestMapping("user")
public class UserController {

    @Autowired
    public UserLoginService userLoginService;

    //注册
    @PostMapping("/register")
    @NullLogin
    public Result Register(@RequestBody @Valid UserRegister userRegister){
        System.out.println(userRegister.toString());
        userLoginService.register(userRegister);
        return Result.OK(null,"发送成功，请查收验证邮件");
    }

    @PostMapping("/set-password")
    @NullLogin
    public Result setPassword(@RequestBody EmailDto emailDto) {
        Result result= userLoginService.setUsernameAndPassword(emailDto);
        return result;
    }

    //验证码
    @PostMapping("/code")
    @NullLogin
    public Result code(@RequestBody @Valid NoteDto noteDto) {
//        System.err.println(noteDto);
        return userLoginService.note(noteDto);
    }

    //手机号登录
    @PostMapping("/login")
    @NullLogin
    public Result login(@RequestBody @Valid UserLoginDto userLoginDto) {
        return userLoginService.login(userLoginDto);
    }

    //账号和密码进行登录
    @PostMapping("/UserPassLogin")
    @NullLogin
    public Result UserPassLogin(@RequestBody @Valid UserPassDto userPassDto) {
        return userLoginService.UserPassLogin(userPassDto);
    }

//    忘记密码
    @PostMapping("/ForgetPass")
    @NullLogin
    public Result ForgetPass(@RequestBody @Valid ForgetPassDto forgetPassDto) {
        return userLoginService.ForgetPass(forgetPassDto);
    }
}
