package com.zhentao.user.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

/**
 * 用户首页表
 * @TableName user_shouye
 */
@TableName(value ="user_shouye")
@Data
public class UserShouye implements Serializable {
    /**
     * 主键
     */
    @TableId
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long id;

    /**
     * 用户1
     */
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long uid1;

    /**
     * 用户2
     */
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long uid2;

    /**
     * 群id
     */
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long gid;

    /**
     * 状态0 1
     */
    private Integer status;

    /**
     * 排序
     */
    private Integer sort;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

    @Override
    public boolean equals(Object that) {
        if (this == that) {
            return true;
        }
        if (that == null) {
            return false;
        }
        if (getClass() != that.getClass()) {
            return false;
        }
        UserShouye other = (UserShouye) that;
        return (this.getId() == null ? other.getId() == null : this.getId().equals(other.getId()))
            && (this.getUid1() == null ? other.getUid1() == null : this.getUid1().equals(other.getUid1()))
            && (this.getUid2() == null ? other.getUid2() == null : this.getUid2().equals(other.getUid2()))
            && (this.getGid() == null ? other.getGid() == null : this.getGid().equals(other.getGid()))
            && (this.getStatus() == null ? other.getStatus() == null : this.getStatus().equals(other.getStatus()))
            && (this.getSort() == null ? other.getSort() == null : this.getSort().equals(other.getSort()));
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((getId() == null) ? 0 : getId().hashCode());
        result = prime * result + ((getUid1() == null) ? 0 : getUid1().hashCode());
        result = prime * result + ((getUid2() == null) ? 0 : getUid2().hashCode());
        result = prime * result + ((getGid() == null) ? 0 : getGid().hashCode());
        result = prime * result + ((getStatus() == null) ? 0 : getStatus().hashCode());
        result = prime * result + ((getSort() == null) ? 0 : getSort().hashCode());
        return result;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", uid1=").append(uid1);
        sb.append(", uid2=").append(uid2);
        sb.append(", gid=").append(gid);
        sb.append(", status=").append(status);
        sb.append(", sort=").append(sort);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}